"""
    Patches Folder.
"""
__version__ = '4.1.0'

import OFS.Folder
import urllib
import Globals

def manage_performWebImport(self, url, id, title='', submit=None, REQUEST=None):
    """ Attempts to perform a WebImport operation. """
    uo=urllib.URLopener()
    ds=uo.open(url)
    info=ds.info()
    data=ds.read()
    return OFS.Image.manage_addFile(self,
        id=id, title=title, file=data,
        content_type=info.getheader('content-type'),
        REQUEST=REQUEST)

targets = (
    OFS.Folder.Folder,
)
manage_options = (
    {'label':'Web Import', 'action':'manage_performWebImportForm',
     'help':('PatchKit', 'WebImport.stx'),
    },
)
methods = {
    'manage_performWebImportForm':
        Globals.DTMLFile('www/WebImport', globals()),
    'manage_performWebImport': manage_performWebImport,
}
